; this code is for decrypting
; standart html files crypted with
; HTMLCrypto v1.00
; 
; it will not decrypt modified files,
; like deleted first info text, or
; some other modifingz...
;
; add generic search routine yourself :)
; use Boyer Moore exact pattern matching algorithm hehe :))
;
;
; SMoKE
;
;
.386
.model          flat, stdcall  
option          casemap :none 

include         \MASM32\INCLUDE\windows.inc
include         \MASM32\INCLUDE\user32.inc
include         \MASM32\INCLUDE\kernel32.inc
include         \MASM32\INCLUDE\comdlg32.inc

includelib      \MASM32\LIB\user32.lib
includelib      \MASM32\LIB\kernel32.lib
includelib      \MASM32\LIB\comdlg32.lib

ERROR		EQU MB_OK + MB_ICONERROR

.DATA
ofnTitle	db "HTMLCrypto v1.00 - Decrypter by SMoKE",0
ofnFilter	db "HTML files...",0,"*.html; *.htm",0,0
err_open	db "CAN NOT OPEN THE FILE SPECIFIED !",0
err_size	db "THE FILE SPECIFIED IS TOO SMALL !",0
err_map		db "CAN NOT MAP THE FILE SPECIFIED TO MEMORY !",0
err_sgn		db "SEEMS THAT THE FILE SPECIFIED IS NOT CRYPTED WITH 'HTMLCrypto v1.00' !",0
err_scasb	db "HMM... STUPID ERROR OCCURED.",13,10
		db "SEEMS THAT THE FILE SPECIFIED IS MODIFIED ?",13,10
		db "CHECK, IS IT RUNS(WORKS) RIGHT ?",13,10
		db "CAN NOT CONTINUE DECRYPTION !",0
err_alloc	db "CAN NOT ALLOCATE MEMORY !",0
new_file	db "de_html.html",0
decrypt_ok	db "THE FILE SPECIFIED IS SUCCESSFULY DECRYPTED (de_html.html) !",0
err_cap		db "ERROR!",0
ok_cap		db "OKAY!",0
ofn		OPENFILENAME <>

.DATA?
fName		db MAX_PATH DUP(?)
fSize		dd ?
hFile		dd ?
hMap		dd ?
pMap		dd ?
pAlloc		dd ?
bwrite		dd ?



.CODE
Main:
	mov     ofn.lStructSize,SIZEOF ofn
	push    0
	pop     ofn.hWndOwner
	push    eax
	pop     ofn.hInstance
	mov     ofn.lpstrFilter, OFFSET ofnFilter
	mov     ofn.lpstrFile, OFFSET fName
	mov     ofn.nMaxFile, 256
	mov     ofn.lpstrTitle, OFFSET ofnTitle
	mov     ofn.Flags, OFN_FILEMUSTEXIST + OFN_HIDEREADONLY
	invoke  GetOpenFileNameA, ADDR ofn
	.IF	eax == FALSE
		invoke	ExitProcess, NULL
	.ENDIF
	invoke	CreateFileA, ADDR fName, GENERIC_READ, FILE_SHARE_READ, \
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	.IF	eax == INVALID_HANDLE_VALUE
		lea	esi, err_open
		call	show_error
	.ENDIF
	mov	hFile, eax
	invoke	GetFileSize, eax, NULL
	.IF	eax < 497 ; HTML with 1 byte is 497 after crypting :)
		invoke	CloseHandle, hFile
		lea	esi, err_size
		call	show_error
	.ENDIF
	mov	fSize, eax
	invoke	CreateFileMappingA, hFile, NULL, PAGE_READONLY, NULL, NULL, NULL
	.IF	eax == NULL
		invoke	CloseHandle, hFile
		lea	esi, err_map
		call	show_error
	.ENDIF
	mov	hMap, eax
	invoke	MapViewOfFile, eax, FILE_MAP_READ, NULL, NULL, fSize
	.IF	eax == NULL
		invoke	CloseHandle, hMap
		invoke	CloseHandle, hFile
		lea	esi, err_map
		call	show_error
	.ENDIF
	mov	pMap, eax
	add	eax, 04Fh
	.IF	dword ptr [eax] != "aTiT" || dword ptr [eax+4] != " SuN" ; kinda signature
		invoke	UnmapViewOfFile, pMap
		invoke	CloseHandle, hMap
		invoke	CloseHandle, hFile
		lea	esi, err_sgn
		call	show_error
	.ENDIF
	add	eax, 0168h
	mov	edi, eax
	sub	eax, eax
	mov	al, 022h ; 022h = "
	mov	ecx, fSize
	sub	ecx, 01B7h
	mov	edx, ecx ; store for length (string start)
_scasb:
	repnz	scasb
	.IF	ecx == 0
		invoke	UnmapViewOfFile, pMap
		invoke	CloseHandle, hMap
		invoke	CloseHandle, hFile
		lea	esi, err_scasb
		call	show_error
	.ENDIF
	.IF	byte ptr [edi] != ";"
		jmp	_scasb
	.ENDIF
	mov	eax, edx
	sub	eax, ecx ; get string length
	dec	eax ; i dont need last byte, its "
	mov	edi, eax ; store in EDI, because GlobalAlloc will modify other regs
	mov	esi, pMap
	add	esi, 01B7h ; get start of string
	invoke	GlobalAlloc, GMEM_FIXED, eax
	.IF	eax == NULL
		invoke	UnmapViewOfFile, pMap
		invoke	CloseHandle, hMap
		invoke	CloseHandle, hFile
		lea	esi, err_alloc
		call	show_error
	.ENDIF
	mov	pAlloc, eax
	mov	ecx, edi ; restore size in ECX
	mov	edx, ecx ; store for LOOP
	mov	edi, eax ; where to MOV
	rep	movsb
	mov	ecx, edx ; restore size
decrypt_loop:
	mov	bl, byte ptr [eax + ecx - 1]
	sub	bl, 3
	mov	byte ptr  [eax + ecx - 1], bl
	loop	decrypt_loop
	mov	esi, edx
; unmap and close all this... then write to nre file and free memory
	invoke	UnmapViewOfFile, pMap
	invoke	CloseHandle, hMap
	invoke	CloseHandle, hFile
	invoke	CreateFileA, ADDR new_file, GENERIC_WRITE, FILE_SHARE_WRITE, \
		NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	mov	hFile, eax
	invoke	WriteFile, eax, [pAlloc], esi, ADDR bwrite, NULL
	invoke	CloseHandle, hFile
	invoke	GlobalFree, pAlloc	
	invoke	MessageBoxA, NULL, ADDR decrypt_ok, ADDR ok_cap, MB_OK + MB_ICONINFORMATION
	jmp	finish_all

show_error:
	invoke	MessageBoxA, NULL, esi, ADDR err_cap, ERROR
finish_all:
	invoke	ExitProcess, NULL
	
end	Main